#include <SQLite.au3>
#include "UDFs\_XMLDomWrapper.au3"
_SQLite_Startup()
$ldatetimestamp = StringFormat("%04i", @YEAR) & '-' & StringFormat("%02i", @MON) & '-' & StringFormat("%02i", @MDAY) & ' ' & @HOUR & '-' & @MIN & '-' & @SEC
Dim $TmpDir = @ScriptDir & '\temp\'
DirCreate($TmpDir)
Dim $GPS_ID = 0
Dim $APID = 0
Dim $HISTID = 0

Dim $VistumblerFile = "C:\Users\Andrew\Downloads\20100620\20100620.VS1"

;Create DB
$VistumblerDB = $TmpDir & $ldatetimestamp & '.sdb'
$DBhndl = _SQLite_Open($VistumblerDB, $SQLITE_OPEN_READWRITE + $SQLITE_OPEN_CREATE, $SQLITE_ENCODING_UTF16)
_SQLite_Exec($DBhndl, "pragma synchronous=0");Speed vs Data security. Speed Wins for now.
_SQLite_Exec($DBhndl, "CREATE TABLE GPS (GPSID,Latitude,Longitude,NumOfSats,HorDilPitch,Alt,Geo,SpeedInMPH,SpeedInKmH,TrackAngle,Date1,Time1)")
_SQLite_Exec($DBhndl, "CREATE TABLE AP (Data)")

;Import VS1
$VS1file = FileOpenDialog("Select VS1 File", '', "Vistumbler file" & ' (*.VS1)', 1)
_ImportVS1($VS1file)

;Import GPX Track
$GPXfile = FileOpenDialog("Select GPX Track File", '', "GPS eXchange Format" & ' (*.GPX)', 1)
_ImportGPX($GPXfile)

;Export to VS1
$Mergedfile = FileSaveDialog("Save Merged File As VS1", "", 'Vistumbler File' & ' (*.VS1)', '', $ldatetimestamp & '.VS1')
_ExportDetailedTXT($Mergedfile)

_SQLite_Close($VistumblerDB)
FileDelete($VistumblerDB)

Func _ExportDetailedTXT($savefile, $Filter = 0);writes vistumbler detailed data to a txt file
	FileWriteLine($savefile, "# Vistumbler VS1 - Detailed Export Version 3.0")
	FileWriteLine($savefile, "# Created By: " & 'VS1=GPX_Merge' & ' ' & '1')

	;Export GIDs
	FileWriteLine($savefile, "# -------------------------------------------------")
	FileWriteLine($savefile, "# GpsID|Latitude|Longitude|NumOfSatalites|HorizontalDilutionOfPrecision|Altitude(m)|HeightOfGeoidAboveWGS84Ellipsoid(m)|Speed(km/h)|Speed(MPH)|TrackAngle(Deg)|Date(UTC y-m-d)|Time(UTC h:m:s.ms)")
	FileWriteLine($savefile, "# -------------------------------------------------")

	Local $GpsMatchArray, $iRows, $iColumns, $iRval
	$query = "SELECT GpsID, Latitude, Longitude, NumOfSats, HorDilPitch, Alt, Geo, SpeedInMPH, SpeedInKmH, TrackAngle, Date1, Time1 FROM GPS ORDER BY Date1, Time1"
	$iRval = _SQLite_GetTable2d($DBhndl, $query, $GpsMatchArray, $iRows, $iColumns)
	$FoundGpsMatch = $iRows
	For $exp = 1 To $FoundGpsMatch
		$ExpGID = $GpsMatchArray[$exp][0]
		$ExpLat = $GpsMatchArray[$exp][1]
		$ExpLon = $GpsMatchArray[$exp][2]
		$ExpSat = $GpsMatchArray[$exp][3]
		$ExpHorDilPitch = $GpsMatchArray[$exp][4]
		$ExpAlt = $GpsMatchArray[$exp][5]
		$ExpGeo = $GpsMatchArray[$exp][6]
		$ExpSpeedMPH = $GpsMatchArray[$exp][7]
		$ExpSpeedKmh = $GpsMatchArray[$exp][8]
		$ExpTrack = $GpsMatchArray[$exp][9]
		$ExpDate = $GpsMatchArray[$exp][10]
		$ExpTime = $GpsMatchArray[$exp][11]
		FileWriteLine($savefile, $ExpGID & '|' & $ExpLat & '|' & $ExpLon & '|' & $ExpSat & '|' & $ExpHorDilPitch & '|' & $ExpAlt & '|' & $ExpGeo & '|' & $ExpSpeedKmh & '|' & $ExpSpeedMPH & '|' & $ExpTrack & '|' & $ExpDate & '|' & $ExpTime)
	Next

	;Export AP Information
	FileWriteLine($savefile, "# ---------------------------------------------------------------------------------------------------------------------------------------------------------")
	FileWriteLine($savefile, "# SSID|BSSID|MANUFACTURER|Authetication|Encryption|Security Type|Radio Type|Channel|Basic Transfer Rates|Other Transfer Rates|Network Type|Label|GID,SIGNAL")
	FileWriteLine($savefile, "# ---------------------------------------------------------------------------------------------------------------------------------------------------------")
	Local $ApMatchArray, $iRows, $iColumns, $iRval
	$query = "SELECT Data FROM AP"
	$iRval = _SQLite_GetTable2d($DBhndl, $query, $ApMatchArray, $iRows, $iColumns)
	$FoundApMatch = $iRows
	For $exp = 1 To $FoundApMatch
		$ExpData = $ApMatchArray[$exp][0]
		FileWriteLine($savefile, $ExpData)
	Next
EndFunc   ;==>_ExportDetailedTXT

Func _ImportGPX($GPXfile)
	$result = _XMLFileOpen($GPXfile)
	$path = "/*[1]"
	$WptArray = _XMLGetChildNodes($path)
	If IsArray($WptArray) Then
		For $X = 1 To $WptArray[0]
			Local $ImpEle, $ImpDate, $ImpTime, $ImpLat, $ImpLon
			Local $aKeys[1], $aValues[1] ;Arrays used for attributes
			If $WptArray[$X] = "trk" Then
				ConsoleWrite("! -------------------------------------------------------------------------------------------> trk" & @CRLF)
				_XMLGetAllAttrib($path & "/*[" & $X & "]", $aKeys, $aValues) ;Retrieve all attributes
				If Not @error Then
					For $y = 0 To UBound($aKeys) - 1
						;ConsoleWrite($aKeys[$Y] & "=" & $aValues[$Y] & ", ") ;Output all attributes
						If $aKeys[$y] = "lat" Then $ImpLat = $aValues[$y]
						If $aKeys[$y] = "lon" Then $ImpLon = $aValues[$y]
						_XMLGetAllAttrib($path & "/*[" & $X & "]", $aKeys, $aValues) ;Retrieve all attributes
					Next
				EndIf
				ConsoleWrite($path & "/*[" & $X & "]" & @CRLF)
				$WptDataPath = $path & "/*[" & $X & "]"
				$WptDataArray = _XMLGetChildNodes($WptDataPath)
				If IsArray($WptDataArray) Then
					;_ArrayDisplay($WptDataArray)
					For $X1 = 1 To $WptDataArray[0]
						$WptFieldPath = $WptDataPath & "/*[" & $X1 & "]"
						$WptFieldValueArray = _XMLGetValue($WptDataPath & "/*[" & $X1 & "]")
						If IsArray($WptFieldValueArray) Then
							;_ArrayDisplay($WptFieldValueArray)
							ConsoleWrite($WptDataArray[$X1] & @CRLF)
							If $WptDataArray[$X1] = "name" Then $ImpGCID = $WptFieldValueArray[1]
							If $WptDataArray[$X1] = "trkseg" Then
								$trksegArray = _XMLGetChildNodes($WptFieldPath)
								If IsArray($trksegArray) Then
									;_ArrayDisplay($trksegArray)
									For $X2 = 1 To $trksegArray[0]
										If $trksegArray[$X2] = "trkpt" Then
											$trkptPath = $WptFieldPath & "/*[" & $X2 & "]"
											_XMLGetAllAttrib($trkptPath, $aKeys, $aValues) ;Retrieve all attributes
											If Not @error Then
												For $y = 0 To UBound($aKeys) - 1
													;ConsoleWrite($aKeys[$Y] & "=" & $aValues[$Y] & ", ") ;Output all attributes
													If $aKeys[$y] = "lat" Then $ImpLat = _Format_GPS_DDD_to_DMM($aValues[$y], "N", "S")
													If $aKeys[$y] = "lon" Then $ImpLon = _Format_GPS_DDD_to_DMM($aValues[$y], "E", "W")
												Next
											EndIf
											$trkptArray = _XMLGetChildNodes($WptFieldPath & "/*[" & $X2 & "]")
											;_ArrayDisplay($trkptArray)
											For $X3 = 1 To $trkptArray[0]
												$trkptDataPath = $trkptPath & "/*[" & $X3 & "]"
												$WptFieldValueArray = _XMLGetValue($trkptPath & "/*[" & $X3 & "]")
												;_ArrayDisplay($WptFieldValueArray)
												If $trkptArray[$X3] = "ele" Then $ImpEle = $WptFieldValueArray[1]
												If $trkptArray[$X3] = "time" Then
													$DTArray = StringSplit($WptFieldValueArray[1], "T")
													$ImpDate = $DTArray[1]
													$ImpTime = StringReplace($DTArray[2], "Z", "")
												EndIf
										Next
										_AddToGpsDB($ImpLat, $ImpLon, $ImpDate, $ImpTime, $ImpEle)
											;If $trkptArray[$X2] = "trkpt" Then ConsoleWrite('trkpt' & @CRLF)
										EndIf
									Next
								EndIf
							EndIf
							If $WptDataArray[$X1] = "urlname" Then $ImpName = $WptFieldValueArray[1]
							If $WptDataArray[$X1] = "url" Then $ImpLink = $WptFieldValueArray[1]
							If $WptDataArray[$X1] = "Notes" Then $ImpNotes = $WptFieldValueArray[1]
						EndIf
					Next
				EndIf
				;ConsoleWrite($ImpLat & " - " & $ImpLon & " - " & $ImpGCID & " - " & $ImpNotes & " - " & $ImpName & " - " & $ImpAuth & " - " & $ImpType & " - " & $ImpDif & " - " & $ImpTer & @CRLF)

				#comments-start
				$WPName = $ImpName
				$WPGCID = $ImpGCID
				$WPNotes = $ImpNotes
				$WPLink = $ImpLink
				$WPAuth = $ImpAuth
				$WPType = $ImpType
				$WPDif = $ImpDif
				$WPTer = $ImpTer
				$DestLat = _Format_GPS_All_to_DMM(StringFormat('%0.7f', $ImpLat), "N", "S")
				$DestLon = _Format_GPS_All_to_DMM(StringFormat('%0.7f', $ImpLon), "E", "W")
				;$DestBrng = StringFormat('%0.1f', _BearingBetweenPoints($StartLat, $StartLon, $DestLat, $DestLon))
				;$DestDist = StringFormat('%0.1f', _DistanceBetweenPoints($StartLat, $StartLon, $DestLat, $DestLon))

				$query = "SELECT TOP 1 WPID FROM WP WHERE Name = '" & StringReplace($WPName, "'", "''") & "' And GCID = '" & StringReplace($WPGCID, "'", "''") & "' And Latitude = '" & $DestLat & "' And Longitude = '" & $DestLon & "'"
				$WpMatchArray = _RecordSearch($MysticacheDB, $query, $DB_OBJ)
				$FoundWpMatch = UBound($WpMatchArray) - 1
				If $FoundWpMatch = 0 Then ;If WP is not found then add it
					$WPID += 1
					;Add APs to top of list
					If $AddDirection = 0 Then
						$query = "UPDATE WP SET ListRow = ListRow + 1 WHERE ListRow <> '-1'"
						_ExecuteMDB($MysticacheDB, $DB_OBJ, $query)
						$DBAddPos = 0
					Else ;Add to bottom
						$DBAddPos = -1
					EndIf
					;Add Into ListView
					$ListRow = _GUICtrlListView_InsertItem($ListviewAPs, $WPID, $DBAddPos)
					_ListViewAdd($ListRow, $WPID, $WPName, $WPGCID, $WPNotes, _GpsFormat($DestLat), _GpsFormat($DestLon), $DestBrng, $DestDist, $WPLink, $WPAuth, $WPType, $WPDif, $WPTer)
					_AddRecord($MysticacheDB, "WP", $DB_OBJ, $WPID & '|' & $ListRow & '|' & $WPName & '|' & $WPGCID & '|' & $WPNotes & '|' & $DestLat & '|' & $DestLon & '|' & $DestBrng & '|' & $DestDist & '|' & $WPLink & '|' & $WPAuth & '|' & $WPType & '|' & $WPDif & '|' & $WPTer)
				EndIf
				#comments-end
			EndIf
		Next

	EndIf
EndFunc   ;==>_ImportGPX

Func _AddToGpsDB($ImpLat, $ImpLon, $ImpDate, $ImpTime, $ImpEle)
	ConsoleWrite($ImpEle & ' - ' & $ImpDate & ' - ' & $ImpTime & ' - ' & $ImpLon & ' - ' & $ImpLat & @CRLF)

$query = "UPDATE GPS SET Latitude='" & $ImpLat & "', Longitude='" & $ImpLon & "' WHERE Date1='" & $ImpDate & "' And Time1 LIKE '" & $ImpTime & "%'"
ConsoleWrite($query & @CRLF)
_SQLite_Exec($DBhndl, $query)


EndFunc

Func _Format_GPS_DDD_to_DMM($gps, $PosChr, $NegChr);converts dd.ddddddd, to ddmm.mmmm
	;dd.ddddddd to ddmm.mmmm
	$return = '0000.0000'
	If StringInStr($gps, '-') Or StringInStr($gps, $NegChr) Then
		$gDir = $NegChr
	Else
		$gDir = $PosChr
	EndIf
	$gps = StringReplace(StringReplace(StringReplace(StringReplace(StringReplace($gps, " ", ""), "-", ""), "+", ""), $PosChr, ""), $NegChr, "")
	$splitlatlon1 = StringSplit($gps, ".")
	If $splitlatlon1[0] = 2 Then
		$DD = $splitlatlon1[1] * 100
		$MM = ('.' & $splitlatlon1[2]) * 60 ;multiply remaining decimal by 60 to get mm.mmmm
		$return = $gDir & ' ' & StringFormat('%0.4f', $DD + $MM);Format data properly (ex. N ddmm.mmmm)
	EndIf
	Return ($return)
EndFunc   ;==>_Format_GPS_DDD_to_DMM

Func _ImportVS1($VS1file)
	$vistumblerfile = FileOpen($VS1file, 0)
	If $vistumblerfile <> -1 Then
		$begintime = TimerInit()
		$currentline = 1
		$AddAP = 0
		$AddGID = 0
		;Get Total number of lines
		$totallines = 0
		While 1
			FileReadLine($vistumblerfile)
			If @error = -1 Then ExitLoop
			$totallines += 1
		WEnd
		;Start Importing File
		For $Load = 1 To $totallines
			$linein = FileReadLine($vistumblerfile, $Load);Open Line in file
			If @error = -1 Then ExitLoop
			If StringTrimRight($linein, StringLen($linein) - 1) <> "#" Then
				ConsoleWrite($linein & @CRLF)
				$loadlist = StringSplit($linein, '|');Split Infomation of AP on line
				_SQLite_Exec($DBhndl, "BEGIN;")
				If $loadlist[0] = 6 Or $loadlist[0] = 12 Then ; If Line is GPS ID Line
					If $loadlist[0] = 6 Then
						$LoadGID = $loadlist[1]
						$LoadLat = _Format_GPS_DMM($loadlist[2])
						$LoadLon = _Format_GPS_DMM($loadlist[3])
						$LoadSat = $loadlist[4]
						$LoadHorDilPitch = 0
						$LoadAlt = 0
						$LoadGeo = 0
						$LoadSpeedKmh = 0
						$LoadSpeedMPH = 0
						$LoadTrackAngle = 0
						$LoadDate = $loadlist[5]
						$ld = StringSplit($LoadDate, '-')
						If StringLen($ld[1]) <> 4 Then $LoadDate = StringFormat("%04i", $ld[3]) & '-' & StringFormat("%02i", $ld[1]) & '-' & StringFormat("%02i", $ld[2])
						$LoadTime = $loadlist[6]
						If StringInStr($LoadTime, '.') = 0 Then $LoadTime &= '.000'
					ElseIf $loadlist[0] = 12 Then
						$LoadGID = $loadlist[1]
						$LoadLat = _Format_GPS_DMM($loadlist[2])
						$LoadLon = _Format_GPS_DMM($loadlist[3])
						$LoadSat = $loadlist[4]
						$LoadHorDilPitch = $loadlist[5]
						$LoadAlt = $loadlist[6]
						$LoadGeo = $loadlist[7]
						$LoadSpeedKmh = $loadlist[8]
						$LoadSpeedMPH = $loadlist[9]
						$LoadTrackAngle = $loadlist[10]
						$LoadDate = $loadlist[11]
						$ld = StringSplit($LoadDate, '-')
						If StringLen($ld[1]) <> 4 Then $LoadDate = StringFormat("%04i", $ld[3]) & '-' & StringFormat("%02i", $ld[1]) & '-' & StringFormat("%02i", $ld[2])
						$LoadTime = $loadlist[12]
						If StringInStr($LoadTime, '.') = 0 Then $LoadTime &= '.000'
					EndIf
					$query = "INSERT INTO GPS(GPSID,Latitude,Longitude,NumOfSats,HorDilPitch,Alt,Geo,SpeedInMPH,SpeedInKmH,TrackAngle,Date1,Time1) VALUES ('" & $LoadGID & "','" & $LoadLat & "','" & $LoadLon & "','" & $LoadSat & "','" & $LoadHorDilPitch & "','" & $LoadAlt & "','" & $LoadGeo & "','" & $LoadSpeedMPH & "','" & $LoadSpeedKmh & "','" & $LoadTrackAngle & "','" & $LoadDate & "','" & $LoadTime & "');"
					_SQLite_Exec($DBhndl, $query)
				ElseIf $loadlist[0] = 13 Then ;If String is VS1 data line
					$Found = 0
					$APData = StringReplace($linein, "'", "''")
					$query = "INSERT INTO AP(Data) VALUES ('" & $APData & "');"
					_SQLite_Exec($DBhndl, $query)
				Else
					;ExitLoop
				EndIf
				_SQLite_Exec($DBhndl, "COMMIT;")
			EndIf
			$currentline += 1
		Next
	EndIf
	FileClose($vistumblerfile)
EndFunc   ;==>_ImportVS1

Func _Format_GPS_DMM($gps)
	$return = '0000.0000'
	$splitlatlon1 = StringSplit($gps, " ");Split N,S,E,W from data
	If $splitlatlon1[0] = 2 Then
		$splitlatlon2 = StringSplit(StringFormat("%0.4f", $splitlatlon1[2]), ".");Split dd from data
		$ls = StringFormat("%04i", $splitlatlon2[1])
		$return = $splitlatlon1[1] & ' ' & StringFormat("%04i", $splitlatlon2[1]) & '.' & $splitlatlon2[2];set return
	EndIf
	Return ($return)
EndFunc   ;==>_Format_GPS_DMM

Func _CompareDate($d1, $d2);If $d1 is greater than $d2, return 1 ELSE return 2
	$d1 = StringReplace(StringReplace(StringReplace(StringReplace(StringReplace($d1, '-', ''), '/', ''), ':', ''), ':', ''), ' ', '')
	$d2 = StringReplace(StringReplace(StringReplace(StringReplace(StringReplace($d2, '-', ''), '/', ''), ':', ''), ':', ''), ' ', '')
	If $d1 = $d2 Then
		Return (0)
	ElseIf $d1 > $d2 Then
		Return (1)
	ElseIf $d1 < $d2 Then
		Return (2)
	Else
		Return (-1)
	EndIf
EndFunc   ;==>_CompareDate